<template>
  <v-card class="pt-3 mt-10" :elevation="2" flat>
    <v-card class="header" color="cyan lighten-5" :elevation="3" absolute>
      <div>
        <v-row class="px-4">
          <v-card-title class="">
            <object
              width="200"
              :key="keyComponent"
              data="../logo_AEMET.svg"
              id="cyrcle-image"
              type="image/svg+xml"
            ></object>
          </v-card-title>
          <v-divider vertical inset></v-divider>
          <div class="col">
            <h1 class="text-center"></h1>
            <h2 class="text-center">Introducir archivos csv</h2>
            <p class="text-center">El eje Y sólo acepta numbers</p>
          </div>
        </v-row>
      </div>
    </v-card>
    <v-card>
      <v-container>
        <v-form v-model="isFormValid">
          <v-form enctype="multipart/form-data">
            <input type="file" @change="loadTextFromFile" />
          </v-form>
          <v-row>
            <v-container>
              <v-checkbox v-model="twoAxis" label="2 ejes Y"
                >2 ejes</v-checkbox
              ></v-container
            > </v-row
          ><v-divider color="cyan"></v-divider>
          <v-row>
            <v-col cols="12" sm="4">
              <v-text-field
                v-model="chartOptions.title"
                label="Título"
                outlined
              >
              </v-text-field>
            </v-col>
          </v-row>
          <v-divider color="cyan"></v-divider>
          <v-row
            ><v-col
              v-for="(item, index) in headers"
              :key="index"
              cols="12"
              sm="3"
            >
              <v-card-title>{{ item }}</v-card-title>
              <v-select
                v-model="typeGraph[index]"
                label="Tipo de grafica"
                :items="typesGraph"
              ></v-select>
              <v-select
                v-model="valueToParse[index]"
                label="formato"
                :items="parseValue"
                @change="parseItem(index)"
              ></v-select
              >{{ typeof result[1][index] }}
            </v-col>
          </v-row>
          <v-divider color="cyan"></v-divider>

          <v-row>
            <v-col cols="12" sm="3">
              <v-text-field
                v-model="chartOptions.hAxis.title"
                label="Título eje X"
                outlined
              ></v-text-field>
              <v-select
                v-model="itemX"
                :items="headers"
                label="Eje X"
                chips
                deletable-chips
              ></v-select
            ></v-col>
            <v-col cols="12" sm="3">
              <v-text-field
                v-model="chartOptions.vAxes[0].title"
                label="Título eje Y"
                outlined
              ></v-text-field>
              <v-select
                v-model="itemY"
                :items="headers"
                label="Eje Y"
                chips
                deletable-chips
                multiple
              ></v-select
            ></v-col>
            <v-col cols="12" sm="3" v-if="twoAxis">
              <v-text-field
                v-model="chartOptions.vAxes[1].title"
                outlined
                label="Título 2º eje X"
              ></v-text-field>
              <v-select
                v-model="itemY2"
                :items="headers"
                label="Eje Y2"
                chips
                deletable-chips
                multiple
              ></v-select
            ></v-col>
            <v-col cols="12" sm="3">
              <v-btn
                :disabled="
                  itemY.length == 0 || itemX.length == 0 || !isFormValid
                "
                color="primary"
                block
                outlined
                @click="showGraph"
                >Show</v-btn
              >
              <v-btn class="mt-1" color="red" block outlined @click="cleanData"
                >Clear</v-btn
              >
              <v-btn
                :disabled="!showingCharts"
                class="mt-1"
                color="primary"
                outlined
                block
                @click="download"
                >Descargar</v-btn
              >
            </v-col>
          </v-row>
        </v-form>
        <div id="chart_div" class="chartWithOverlay">
          <GChart
            v-if="showingCharts"
            id="visualization"
            :data="chartData"
            :options="chartOptions"
            type="LineChart"
            @ready="onChartReady"
          >
          </GChart>
        </div>

        <v-overlay :value="loading">
          <v-progress-circular indeterminate size="64"></v-progress-circular>
        </v-overlay>
      </v-container>
    </v-card>
  </v-card>
</template>

<script>
import { GChart } from "vue-google-charts";

export default {
  components: { GChart },
  data() {
    return {
      isFormValid: false,
      keyComponent: 0,
      isChart: false,
      readchart: false,
      isDownloaded: false,
      loading: false,
      twoAxis: false,
      showingCharts: false,
      headers: [],
      parseValue: ["número", "fecha"],
      typesGraph: ["line", "scatter"],
      valueToParse: [],
      result: [],
      pureResult: [],
      typeGraph: [],
      chartData: [],
      file: null,
      image: null,
      itemX: [],
      itemY: [],
      itemY2: [],
      downloaded: false,
      chartOptions: {
        pointSize: 1,
        height: 800,
        width: 1700,
        title: "",
        theme: {
          chartArea: { width: "90%", height: "80%" },
          legend: { position: "in" }
        },
        vAxes: {
          0: {
            title: "",
            gridlines: { color: "#efefef", minSpacing: 50 },
            viewWindowMode: "pretty"
          },
          1: {
            title: "",
            gridlines: { color: "transparent" },
            viewWindowMode: "pretty"
          }
        },
        hAxis: {
          title: "",
          format: "yyyy",
          viewWindowMode: "pretty",
          gridlines: {
            color: "#efefef",
            minSpacing: 50
          }
        },
        series: {}
      }
    };
  },

  methods: {
    onChartReady(chart, google) {
      this.loading = false;
      var _this = this;
      //
      window.google.visualization.events.addListener(
        chart,
        "ready",
        function() {
          var e = document.getElementById("visualization");
          var svg = e.getElementsByTagName("svg")[0];
          svg.setAttribute("xmlns", "http://www.w3.org/2000/svg");
          var D = document.querySelector("object");
          console.log(D);
          var G = D.contentDocument.getElementsByTagName("svg")[0];
          G.setAttributeNS(null, "x", "75%");
          G.setAttributeNS(null, "y", "70%");
          G.setAttributeNS(null, "width", "20%");
          G.setAttributeNS(null, "height", "15%");
          svg.appendChild(G);
          _this.keyComponent++;
        }
      );
    },

    loadTextFromFile(ev) {
      this.loading = true;
      const file = ev.target.files[0];
      const reader = new FileReader();
      reader.onload = e => {
        this.csvToJSON(e.target.result);
        this.pureResult = e.target.result;
        // return this.$emit("load", e.target.result);
      };
      try {
        reader.readAsText(file);
      } catch (e) {
      } finally {
        this.loading = false;
      }
    },

    csvToJSON(csv) {
      var lines = csv.split("\n");
      this.headers = lines[0].split(",");
      this.result.push(this.headers);
      this.headers.forEach(item => {
        this.typeGraph.push("line");
      });
      for (let i = 1; i < lines.length; i++) {
        if (
          this.splitCSVButIgnoreCommasInDoublequotes(lines[i]).length ==
          this.splitCSVButIgnoreCommasInDoublequotes(lines[i - 1]).length
        ) {
          this.result.push(
            this.splitCSVButIgnoreCommasInDoublequotes(lines[i])
          );
        }
      }
      this.valueToParse = new Array(this.headers.length);
    },

    parseItem(index) {
      try {
        if (this.valueToParse[index] == "número") {
          for (let i = 1; i < this.result.length; i++) {
            var value = this.result[i][index].replace(",", ".");
            value = value.replace('"', "");
            this.result[i][index] = parseFloat(value);
          }
        } else if (this.valueToParse[index] == "fecha") {
          for (let i = 1; i < this.result.length; i++) {
            this.result[i][index] = new Date(Date.parse(this.result[i][index]));
          }
        }
      } catch (e) {
        this.cleanData();
      }
    },

    splitCSVButIgnoreCommasInDoublequotes(str) {
      //split the str first
      //then merge the elments between two double quotes
      var delimiter = ",";
      var quotes = '"';
      var elements = str.split(delimiter);
      var newElements = [];
      for (var i = 0; i < elements.length; ++i) {
        if (elements[i].indexOf(quotes) >= 0) {
          //the left double quotes is found
          var indexOfRightQuotes = -1;
          var tmp = elements[i];
          //find the right double quotes
          for (var j = i + 1; j < elements.length; ++j) {
            if (elements[j].indexOf(quotes) >= 0) {
              indexOfRightQuotes = j;
              break;
            }
          }
          //found the right double quotes
          //merge all the elements between double quotes
          if (-1 != indexOfRightQuotes) {
            for (var j = i + 1; j <= indexOfRightQuotes; ++j) {
              tmp = tmp + delimiter + elements[j];
            }
            newElements.push(tmp);
            i = indexOfRightQuotes;
          } else {
            //right double quotes is not found
            newElements.push(elements[i]);
          }
        } else {
          //no left double quotes is found
          newElements.push(elements[i]);
        }
      }

      return newElements;
    },

    showGraph() {
      try {
        var itemsToShow = [];
        this.headers.forEach(item => {
          if (this.itemX.includes(item)) {
            itemsToShow.push(this.headers.indexOf(item));
          }
        });

        this.headers.forEach(item => {
          if (this.itemY.includes(item) || this.itemY2.includes(item)) {
            itemsToShow.push(this.headers.indexOf(item));
          }
        });

        this.chartData = new Array(this.result.length);

        for (let i = 0; i < this.result.length; i++) {
          this.chartData[i] = new Array(itemsToShow.length);
          for (let j = 0; j < this.result[i].length; j++) {
            if (itemsToShow.includes(j)) {
              var position = itemsToShow.indexOf(j);
              this.chartData[i][position] = this.result[i][j];
            }
          }
        }

        for (let i = 0; i < this.chartData.length; i++) {
          for (let j = 0; j < this.chartData[0].length; j++) {
            if (this.itemY.includes(this.chartData[0][j])) {
              this.chartOptions.series[j - 1] = { targetAxisIndex: 0 };
            } else if (this.itemY2.includes(this.chartData[0][j])) {
              this.chartOptions.series[j - 1] = { targetAxisIndex: 1 };
            }
          }
        }

        for (let i = 1; i < itemsToShow.length; i++) {
          this.chartOptions.series[i - 1].type = this.typeGraph[itemsToShow[i]];
        }
        this.showingCharts = true;
      } catch (e) {
        console.log(e);
      } finally {
      }
    },
    download() {
      var e = document.getElementById("visualization");
      var svg = e.getElementsByTagName("svg")[0];
      if (!svg) return;
      var svgBlob = new Blob([svg.outerHTML], {
        type: "image/svg+xml;charset=utf-8"
      });
      var svgUrl = URL.createObjectURL(svgBlob);

      var downloadLink = document.createElement("a");
      downloadLink.href = svgUrl;
      downloadLink.download = `${
        this.chartOptions.title
      }-${new Date().toISOString()}.svg`;
      document.body.appendChild(downloadLink);
      downloadLink.click();
      document.body.removeChild(downloadLink);
    },

    cleanData() {
      this.isDownloaded = false;
      this.isChart = false;
      this.showingCharts = false;
      this.headers = [];
      this.valueToParse = [];
      this.result = [];
      this.chartData = [];
      this.itemX = [];
      this.itemY = [];
      this.csvToJSON(this.pureResult);
    }
  }
};
</script>
<style scoped>
.header {
  margin-left: 10px;
  margin-right: 10px;
  z-index: 1;
  margin-top: -40px;
}
.chartWithOverlay {
  position: relative;
  width: 700px;
}
.overlay {
  width: 200px;
  height: 200px;
  position: absolute;
  top: 60px; /* chartArea top  */
  left: 180px; /* chartArea left */
}
</style>
